module Tut10 where

import System.IO
import System.Random (randomRIO)
import Text.Read (readMaybe)

{-T10.1-}
ioReadPrintInt :: IO ()
ioReadPrintInt = do
  input <- getLine
  case readMaybe input :: Maybe Int of
    Just i -> print i
    Nothing -> putStrLn $ "Input is not a number: " ++ input

ioLoop :: (a -> Maybe b) -> IO a -> IO b
ioLoop f act = do
    x <- act
    case f x of
        Nothing -> ioLoop f act
        Just b -> return b

getInt :: IO Int
getInt = ioLoop readMaybe getLine

{-T10.2-}
guessNum :: IO Int
guessNum = do
    rnd <- randomRIO (0,100)
    putStrLn "Guess a number between 0 and 100"
    doGuessNum rnd 1
  where
    doGuessNum rnd cnt = do
      num <- getInt
      if num < rnd then do
        putStrLn "The number you are looking for is greater"
        doGuessNum rnd (cnt+1)
      else if num > rnd then do
        putStrLn "The number you are looking for is smaller"
        doGuessNum rnd (cnt+1)
      else do
        putStrLn "You found it!"
        return cnt

{- T10.3 -}
ioSequence :: [IO a] -> IO [a]
ioSequence [] = return []
ioSequence (io : ios) = do
  a <- io
  as <- ioSequence ios
  return $ a : as

ioSumInts :: IO Int 
ioSumInts = do
  n <- getInt
  xs <- ioSequence $ replicate n getInt
  print xs
  return $ sum xs
